--- old/usr/src/uts/common/exec/elf/elf_notes.c	Wed Apr 12 20:33:30 2023
+++ new/usr/src/uts/common/exec/elf/elf_notes.c	Wed Apr 12 20:33:30 2023
@@ -28,7 +28,7 @@
  * Copyright 2012 DEY Storage Systems, Inc.  All rights reserved.
  * Copyright 2018 Joyent, Inc.
  * Copyright 2020 OmniOS Community Edition (OmniOSce) Association.
- * Copyright 2022 Oxide Computer Company
+ * Copyright 2023 Oxide Computer Company
  */
 
 #include <sys/types.h>
@@ -138,7 +138,7 @@
 		v[0].p_filesz += sizeof (Note) + roundup(size, sizeof (Word));
 #endif	/* __i386_COMPAT */
 
-	if ((size = prhasx(p)? prgetprxregsize(p) : 0) != 0)
+	if ((size = prhasx(p) ? prgetprxregsize(p) : 0) != 0)
 		v[0].p_filesz += nlwp * sizeof (Note)
 		    + nlwp * roundup(size, sizeof (Word));
 
@@ -197,7 +197,7 @@
 		prupanic_t	upanic;
 	} *bigwad;
 
-	size_t xregsize = prhasx(p)? prgetprxregsize(p) : 0;
+	size_t xregsize = prhasx(p) ? prgetprxregsize(p) : 0;
 	size_t crsize = sizeof (prcred_t) + sizeof (gid_t) * (ngroups_max - 1);
 	size_t psize = prgetprivsize();
 	size_t bigsize = MAX(psize, MAX(sizeof (*bigwad),
@@ -574,7 +574,7 @@
 #endif /* __sparc */
 
 		if (xregsize) {
-			prgetprxregs(lwp, bigwad->xregs);
+			prgetprxregs(lwp, (prxregset_t *)bigwad->xregs);
 			error = elfnote(vp, &offset, NT_PRXREG,
 			    xregsize, bigwad->xregs, rlimit, credp);
 			if (error)
--- old/usr/src/uts/common/exec/elf/old_notes.c	Wed Apr 12 20:33:30 2023
+++ new/usr/src/uts/common/exec/elf/old_notes.c	Wed Apr 12 20:33:30 2023
@@ -57,11 +57,16 @@
 extern void oprgetstatus(kthread_t *, prstatus_t *, zone_t *);
 extern void oprgetpsinfo(proc_t *, prpsinfo_t *, kthread_t *);
 
+/*
+ * Historically the system dumped the xreg note when on SPARC. Because we no
+ * longer support SPARC we do not dump the old note form of the xregs for any
+ * additional platforms. Please do not add this back unless it's for SPARC's
+ * future resurrection.
+ */
 void
 setup_old_note_header(Phdr *v, proc_t *p)
 {
 	int nlwp = p->p_lwpcnt;
-	size_t size;
 
 	v[0].p_type = PT_NOTE;
 	v[0].p_flags = PF_R;
@@ -71,30 +76,10 @@
 	    + roundup(__KERN_NAUXV_IMPL * sizeof (aux_entry_t),
 	    sizeof (Word))
 	    + nlwp * roundup(sizeof (prstatus_t), sizeof (Word));
-	if (prhasfp())
-		v[0].p_filesz += nlwp * sizeof (Note)
-		    + nlwp*roundup(sizeof (prfpregset_t), sizeof (Word));
-	if ((size = prhasx(p)? prgetprxregsize(p) : 0) != 0)
-		v[0].p_filesz += nlwp * sizeof (Note)
-		    + nlwp * roundup(size, sizeof (Word));
-
-#if defined(__sparc)
-	/*
-	 * Figure out the number and sizes of register windows.
-	 */
-	{
-		kthread_t *t = p->p_tlist;
-		do {
-			if ((size = prnwindows(ttolwp(t))) != 0) {
-				size = sizeof (gwindows_t) -
-				    (SPARC_MAXREGWINDOW - size) *
-				    sizeof (struct rwindow);
-				v[0].p_filesz += sizeof (Note) +
-				    roundup(size, sizeof (Word));
-			}
-		} while ((t = t->t_forw) != p->p_tlist);
+	if (prhasfp()) {
+		v[0].p_filesz += nlwp * sizeof (Note) +
+		    nlwp * roundup(sizeof (prfpregset_t), sizeof (Word));
 	}
-#endif /* __sparc */
 }
 
 int
@@ -105,14 +90,9 @@
 		prpsinfo_t	psinfo;
 		prstatus_t	prstat;
 		prfpregset_t	fpregs;
-#if defined(__sparc)
-		gwindows_t	gwindows;
-#endif /* __sparc */
-		char		xregs[1];
 		aux_entry_t	auxv[__KERN_NAUXV_IMPL];
 	} *bigwad;
-	int xregsize = prhasx(p)? prgetprxregsize(p) : 0;
-	size_t bigsize = MAX(sizeof (*bigwad), (size_t)xregsize);
+	size_t bigsize = sizeof (*bigwad);
 	kthread_t *t;
 	klwp_t *lwp;
 	user_t *up;
@@ -199,35 +179,6 @@
 			    rlimit, credp);
 			if (error)
 				goto done;
-		}
-
-#if defined(__sparc)
-		/*
-		 * Unspilled SPARC register windows.
-		 */
-		{
-			size_t size = prnwindows(lwp);
-
-			if (size != 0) {
-				size = sizeof (gwindows_t) -
-				    (SPARC_MAXREGWINDOW - size) *
-				    sizeof (struct rwindow);
-				prgetwindows(lwp, &bigwad->gwindows);
-				error = elfnote(vp, &offset, NT_GWINDOWS,
-				    size, (caddr_t)&bigwad->gwindows,
-				    rlimit, credp);
-				if (error)
-					goto done;
-			}
-		}
-#endif /* __sparc */
-
-		if (xregsize) {
-			prgetprxregs(lwp, bigwad->xregs);
-			error = elfnote(vp, &offset, NT_PRXREG,
-			    xregsize, bigwad->xregs, rlimit, credp);
-			if (error)
-				goto done;
 		}
 	} while ((t = t->t_forw) != curthread);
 	ASSERT(nlwp == 0);
